/*
 * Data reading class
 * Author: Bart Goethals
 * Author: Michael Mampaey
 * Date: 2009-03-27
 */

#include "data.h"

using namespace std;



template <class T> Transaction<T>::Transaction(const Transaction &tr) : length(tr.length)
{
	t = new T[length];
	for (int i=0; i< length; ++i)
		t[i] = tr.t[i];
}



Data::Data(char *filename) : fn(filename), sep(' ')
{
	in = fopen(fn, "rt");
}


Data::~Data()
{
	if (in) fclose(in);
}


Transaction<string> *Data::getHeader() {
	fpos_t cur_pos;
	fgetpos(in, &cur_pos);
	rewind(in);
	vector<string> *line = getLine();
	if (line) {
		Transaction<string> *header = new Transaction<string>(line->size());
		for (int i=0; i<int(line->size()); i++)
			header->t[i] = (*line)[i];
		delete line;
		return header;
	}
	else
		return 0;
	fsetpos(in, &cur_pos);
}


vector<string> *Data::getLine() {
	char c;
	vector<string> *line = new vector<string>();

	if (feof(in)) {
		delete line;
		return 0;
	}

	do {
		string val;
		while ((c=getc(in))==sep && !feof(in));

		while (c!=sep && c!='\n' && !feof(in)) {
			val.push_back(c);
			c = getc(in);
		}
		if (!feof(in) && val.size())
			line->push_back(val);

	} while (c!='\n' && !feof(in));

	if (feof(in)) {
		delete line;
		return 0;
	}

	return line;
}


Transaction<int> *Data::getNext()
{
	char c;
	vector<int> line;

	if (feof(in)) {
		return 0;
	}

	do {
		int val = 0;
		while ((c=getc(in))==sep && !feof(in));

		while (c!=sep && c!='\n' && !feof(in)) {
			val *= 10;
			val += int(c) - int('0');
			c = getc(in);
		}
		if (!feof(in) && val)
			line.push_back(val);

	} while (c!='\n' && !feof(in));

	if (feof(in)) {
		return 0;
	}

	Transaction<int> *t = new Transaction<int>(line.size());
	for (int i=0; i<int(line.size()); i++)
		t->t[i] = line[i];

	return t;

}
