/*
 * Data reading class
 * Author: Bart Goethals
 * Author: Michael Mampaey
 * Date: 2009-03-27
 */


#include <stdio.h>
#include <vector>
#include <string>

using namespace std;


#ifndef TRANSACTION_H
#define TRANSACTION_H

template <class T> class Transaction
{
public:
	Transaction(int len) : length(len) { t = new T[len]; }
	Transaction(const Transaction &tr);
	~Transaction() { delete [] t; }

	const int length;
	T *t;
};

#endif //TRANSACTION_H


#ifndef DATA_H
#define DATA_H

class Data
{
public:
	Data(char *filename);
	~Data();

	Transaction<string> *getHeader();
	Transaction<int> *getNext();

private:
	vector<string> *getLine();

	FILE *in;
	const char *fn;
	const char sep;
};

#endif //DATA_H

