/*
 * TidList & Item classes
 * Author: Bart Goethals
 * Author: Michael Mampaey
 */

#include "tidlist.h"

using namespace std;


#ifndef ITEM_H
#define ITEM_H

class Item
{
public:
	Item(unsigned i, bool dummy) : id(i), support(0), entropy(0.0), tidlist(0) { }
	Item(unsigned i, unsigned s = 0, double e = 0.0) : id(i), support(s), entropy(e) { tidlist = new TidList(); }
	Item(const Item &it) : id(it.id), support(it.support), entropy(it.entropy) { tidlist = new TidList(*(it.tidlist)); }
	~Item() { delete tidlist; }

	//bool operator< (const Item &i) const { return id < i.id; }
	bool operator< (const Item &i) const { return (entropy==i.entropy) ? id < i.id : entropy > i.entropy ; }

	void set_tid_list(TidList *tl) { delete tidlist; tidlist = tl; }

	mutable unsigned id;
	unsigned support;
	double entropy;
	mutable TidList *tidlist;
};

#endif //ITEM_H
