/*
 * TidList class
 * Author: Michael Mampaey
 */

#ifndef TIDLIST_H
#define TIDLIST_H

class TidList // always sorted, including adding
{
public:
	TidList(unsigned s=blocksize);
	TidList(TidList &t);
	~TidList();

	void add(unsigned elt);
	TidList *intersect(const TidList *t) const ;
	TidList *difference(const TidList *t) const;

	void setlist(unsigned *l);

	unsigned size;
	unsigned *list;

private:
	void resize(unsigned newsize=0);

	unsigned listsize;

	static const int blocksize = 2000;
	static const int autoresize = 10;
};

#endif //TIDLIST_H
